#!/usr/bin/perl
#==========================================================================#
#  B.Forum Ver.1.02                                                      #
#  󥹥ȡ                                                          #
#  Encode = EUC                                                          #
#  Sakuma,Hiroaki ( sakuma@beetas.org )                                  #
#  BEETAS.org ( info@beetas.org )                                        #
#                                                                          #
# Υץꥱϥץ󥽡Ǥ.                          #
# ̵ǻѤ뤳ȤǤޤ.                                            #
# ʤ, ܺ٤ʻѾ/ǿˤĤƤϲȤ.           #
# http://www.beetas.org/                                                   #
#                                                                          #
# ------------------------------------------------------------------------ #
# Copyright 2004 Sakuma,Hiroaki All Rights Reserved.                       #
# Copyright 2004 BEETAS.org All Rights Reserved.                           #
#                                                                          #
#==========================================================================#

$VERSION = '1.02B-1';
$REVISION = '1.02.0065';

$INSTALLDIR = "./.install";
$HTTPSITE = "www.beetas.org";

## Linux
%COMMAND = (gzip => "/bin/gzip", tar  => "/bin/tar", perl => "/usr/bin/perl", make => "/usr/bin/make", cp   => "/bin/cp");

## FreeBSD
#%COMMAND = (gzip => "/usr/bin/gzip", tar  => "/usr/bin/tar", perl => "/usr/bin/perl", make => "/usr/bin/make", cp   => "/bin/cp");

@COPYDIR = (
	["auto", 7],
	["auto/Bforum", 7, 6],
	["B.Forum", 7, 6],
	["B.Forum/.cache", 7],
	["B.Forum/.language", 7, 6],
	["B.Forum/.PLUGIN", 7, 6],
	["B.Forum/Images/files/Images/Images", 7, 6],
	["B.Forum/var/log", 7, 6],
);
@COPYFILE = (
	[".bforumrc", 6],
	["a2b.pl", 7],
	["b2a.pl", 7],
	["b2n.pl", 7],
	["bforum.cgi", 7],
	["sort.pl", 7],
	["Bforum.pm", 6],
	["jcode.pl", 6],
);



use strict;
$| = 1;
umask(000);

require 5.005;

use vars qw($VERSION $REVISION $INSTALLDIR $LANGUAGE $HTTPSITE);
use vars qw(@QUERY @COPYFILE @COPYDIR);
use vars qw(%in %TEXT %COMMAND);

use Cwd;
use File::Path;
use File::Copy;

&main;



sub main {

	my($print);

	no strict;

	&decode;
	&language;

	print "Content-type: text/html; cahrset=EUC-JP\n\n";
	print &open("$INSTALLDIR/BF.install.head");

	if ($in{'stage'}) {
		$print = &{stage . $in{'stage'}};
	} else {
		$print = &top;
	}

	print &open("$INSTALLDIR/BF.install.foot");

}

sub top {

	&print(&open("$INSTALLDIR/BF.install.top"));

}

sub stage1 {

	use Sys::Hostname;

	$in{'install'} = Cwd::cwd();
	$in{'address'} = getlogin . "\@" . (hostname() || $ENV{'REMOTE_HOST'} || gethostbyaddr(pack("C4",split(/\./,$ENV{'REMOTE_ADDR'})),2));

	$in{'stage'} = "2";

	&print(&open("$INSTALLDIR/BF.install.stage1"));
}

sub stage2 {

	my($return);
	my($tmp1,$tmp2,$tmp3);
	my(%tmp4);

	&print(&open("$INSTALLDIR/BF.install.stage2.head"));

	&print(&downloadslist(\%tmp4,$tmp3));
	if ($tmp3) {

		$tmp1 = Cwd::cwd();

		if (!-d $in{'install'}) { mkpath("$in{'install'}"); }

		foreach (keys %tmp4) {

			mkpath("tmp",undef,0700);

			foreach (split(/,/,$tmp4{$_})) {
				undef $tmp2;
				&print(&download($_,$tmp2));
				if ($tmp2) {
					&print(&perlmodule_install($tmp1,$tmp2));
					last;
				}
			}

			rmtree("tmp",undef,undef);

		}

	} else {

		&print("HTTP($HTTPSITE)³Ǥޤ$!");

	}

	$in{'stage'} = "3";

	&print(&open("$INSTALLDIR/BF.install.stage2.foot"));

}

sub stage3 {

	my($return);
	my($tmp1,$tmp2,$tmp3);

	&print(&open("$INSTALLDIR/BF.install.stage3.head"));

	eval("getpwnam(stat($0))");

	if ($@) {
		$tmp1 = 077;
		$tmp2 = 022;
	} else {
		if (getpwnam((stat($0))[4]) eq getlogin || !getlogin || getlogin =~ /^(?:root|SYSTEM)$/) {
			## FTP = WWW
			$tmp1 = 077;
			$tmp2 = 022;
		} else {
			## FTP != WWW
			$tmp1 = 070;
			$tmp2 = 020;
		}
	}

	foreach (@COPYDIR) {
		&print(&copy_dir("$_->[0]","$in{'install'}/$_->[0]",oct("$_->[1]$_->[1]$_->[1]") & ~$tmp1,oct("$_->[2]$_->[2]$_->[2]") & ~$tmp1));
	}

	foreach (@COPYFILE) {
		&print(&copy_file("$_->[0]","$in{'install'}/$_->[0]",oct("$_->[1]$_->[1]$_->[1]") & ~$tmp1));
	}

	&permission(0777 & ~$tmp2,$in{'install'});

	&print("ѹޤ\n");
	$tmp3 = &open("$in{'install'}/.bforumrc");
	$tmp3 =~ s/ADDRESS(.*?)\n/ADDRESS             $in{'address'}\n/g;
	$tmp3 =~ s/LANGUAGE(.*?)\n/LANGUAGE            $in{'language'}\n/g;
	$tmp3 =~ s/UMASK(.*?)\n/"UMASK               " . sprintf("%03o",$tmp1) . "\n"/ge;
	&write("$in{'install'}/.bforumrc",$tmp3);

	&print("ѥɤꤷޤ\n");
	eval("use MD5");

	if ($@) {
		&print("ѥɤǤޤ\n");
	} else {
		&write("$in{'install'}/B.Forum/.passwd",MD5->hexhash($in{'passwd'}));
	}

	$in{'stage'} = "4";

	&print(&open("$INSTALLDIR/BF.install.stage3.foot"));

}

sub stage4 {

	my($return);
	my($tmp1,$tmp2);

	$return = &open("$INSTALLDIR/BF.install.stage4");

#	$tmp1 = $0;
	$tmp1 = $ENV{'SCRIPT_FILENAME'} || $0;
	$tmp1 =~ s/$ENV{'SCRIPT_NAME'}$//;
	$tmp2 = $in{'install'};
	$tmp2 =~ s/^$tmp1//;
	$tmp2 .= "/bforum.cgi";

	$return =~ s/{install}/$in{'install'}/g;
	$return =~ s/{address}/$in{'address'}/g;
	$return =~ s/{passwd}/"*" x length($in{'passwd'})/ge;
	$return =~ s/{language}/$in{'language'}/g;
	$return =~ s/{access}/$tmp2/g;

	&print($return);

}

sub downloadslist {

	my($return);
	my($tmp1,$tmp2,$tmp3);

	mkpath("tmp",undef,0700);

	$return = &download("http://$HTTPSITE/Installer/bforum-$REVISION",$tmp1);

	$tmp2 = &open("tmp/$tmp1");
	rmtree("tmp",undef,undef);

	foreach $tmp3 (split("\n",$tmp2)) {
		chomp ($tmp3);
		if ($tmp3 =~ /^\s*#/o) { next; }
		($tmp3) = split (/#\s+/,$tmp3);
		($tmp3) = split (/\s+#/,$tmp3);
		if (!$tmp3) { next; }
		if ($tmp3 =~ /\s*([^\s]+?)\s+(.*?)\s*$/gio) { ${$_[0]}{$1} = $2; }

	}

	$_[1] = 1;

	return $return;

}

sub download {

	my($return);
	my($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$return = "$_[0]ɤޤ\n";

	if ($_[0] =~ /http:\/\//) {

		use Socket;

		if ($_[0] =~ /http:\/\/([^\/]*)(.*)\/(.*)$/) {

			$tmp2 = $1;
			$tmp3 = $2;
			$tmp4 = $3;

			$return .= "HTTP($tmp2)³Ƥޤ\n";

			if (socket(HTTP,PF_INET,SOCK_STREAM,getprotobyname('tcp')) && connect(HTTP,sockaddr_in(80,inet_aton($tmp2)))) {

				send(HTTP,"GET $tmp3/$tmp4 HTTP/1.0\r\n",0);
				send(HTTP,"Host: $tmp2\r\n",0);
				send(HTTP,"UserAgent: B.ForumInstaller/$VERSION($REVISION)\r\n",0);
				send(HTTP,"\r\n",0);

				$return .= "ե($tmp4)Ƥޤ\n";

				while (read(HTTP,$tmp1,1024) > 0) {
					$tmp2 .= $tmp1;
				}

				close(HTTP);

				## إå򥫥å
				$tmp2 =~ s/^.*?(\r?\n)\1//s;

				&write("tmp/$tmp4",$tmp2);

				$_[1] = $tmp4;

			}

		}

	} elsif ($_[0] =~ /ftp:\/\//) {

		eval("use Net::FTP");

		if (!$@) {

			if ($_[0] =~ /ftp:\/\/([^\/]*)(.*)\/(.*)$/) {

				$tmp2 = $1;
				$tmp3 = $2;
				$tmp4 = $3;

				$return .= "FTP($tmp2)³Ƥޤ\n";

				$tmp5 = Net::FTP->new($tmp2, Timeout => 10, Passive => 1);

				if (defined $tmp5) {

					$return .= "ե($tmp4)Ƥޤ\n";

					$tmp5->login("anonymous",$in{'address'});
					$tmp5->binary;
					$tmp5->get("$tmp3/$tmp4","tmp/$tmp4") || ($return .= "ե($tmp4)Ǥޤ\n");
					$tmp5->quit;

					if (-f "tmp/$tmp4") { $_[1] = $tmp4; }

				} else {

					$return .= "FTP($tmp2)³Ǥޤ\n";

				}

			}

		} else {

			$return .= "Net::FTP󥹥ȡ뤵Ƥޤ\n";

		}

	}

	return $return;

}

sub perlmodule_install {

	my($return);
	my($tmp1);

	if (-x $COMMAND{'gzip'} && -x $COMMAND{'tar'} && -x $COMMAND{'perl'} && -x $COMMAND{'make'} && -x $COMMAND{'cp'}) {

		chdir("$_[0]/tmp/");

		$return = "Ÿޤ\n";
		&command("$COMMAND{'gzip'} -cd $_[1] | $COMMAND{'tar'} -xf -");

		if ($tmp1 = &search_makefile("./")) {

			if ($tmp1 =~ /^(.*)\/(.*)$/) {

				chdir("$_[0]/tmp/$1/");

				$return .= "Makefileޤ\n";
				&command("$COMMAND{'perl'} Makefile.PL PREFIX=\"$in{'install'}\"");

				$return .= "ѥ뤷ޤ\n";
				&command("$COMMAND{'make'}");

				$return .= "ƥȤޤ\n";
				&command("$COMMAND{'make'} test");

				$return .= "󥹥ȡ뤷ޤ\n";
				&command("$COMMAND{'cp'} -fR ./blib/lib/* $in{'install'}");
				&command("$COMMAND{'cp'} -fR ./blib/arch/* $in{'install'}");

			}

		}

		chdir("$_[0]/");

	} else {

		$return .= "ޥɤĤʤ᥹åפޤ\n";

	}

	return $return;

}

sub command {

	open (CMD,"$_[0] |");
	close (CMD);

	return;

}

sub search_makefile {

	my($tmp1);
	my(@tmp2);

	foreach (<$_[0]/*>) {
		if (-d $_) { push (@tmp2,$_); }
		if (-f $_ && $_ =~ /\/Makefile.PL$/) { return($_); }
	}

	foreach (@tmp2) {
		$tmp1 = &search_makefile ($_);
		if ($tmp1) { return($tmp1) };
	}

	return;

}

sub copy_dir {

	my($return);
	my($tmp1);

	$return .= "ǥ쥯ȥ($_[0])򥳥ԡƤޤ(" . sprintf("%o",$_[2]) . ")\n";

	if (!-d "$_[1]") { mkpath("$_[1]"); }
	$return .= &permission($_[2],$_[1]);

	opendir(DIR,$_[0]);
	while ($tmp1 = readdir(DIR)) {
		if (-f "$_[0]/$tmp1") { $return .= &copy_file("$_[0]/$tmp1","$_[1]/$tmp1",$_[3]); }
	}
	closedir(DIR);

	return $return;

}

sub copy_file {

	my($return);

	$return .= "ե($_[0])򥳥ԡƤޤ(" . sprintf("%o",$_[2]) . ")\n";

	if ($_[0] ne $_[1]) {
		if (-f $_[1]) { rename("$_[1]","$_[1].old"); }
		copy ($_[0],$_[1]) || ($return .= "ե($_[0])򥳥ԡǤޤ($!)\n");
	}
	$return .= &permission($_[2],$_[1]);

	return $return;

}

sub permission {

	my($return);

	chmod($_[0],$_[1]);

	return $return;

}

sub form {

	return $_[0] =~ s/<form (.*?)action=(["']?){cgi}\2(.*?)>(.*?)<\/form>/&_form/egios;

}

sub _form {

	my($tmp1,$tmp2,$tmp3,$tmp4);

	$tmp1 = $1;
	$tmp2 = $2;
	$tmp3 = $3;
	$tmp4 = $4;

	$tmp4 =~ s/<select (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/select>/&_form_select/egos;
	$tmp4 =~ s/<input (.*?)name=(["']?)(.*?)\2(.*?)>/&_form_input/egos;
	$tmp4 =~ s/<textarea (.*?)name=(["']?)(.*?)\2(.*?)>(.*?)<\/textarea>/&_form_textarea/egos;

	return "<form " . $tmp1 . "action=" . $tmp2 . $ENV{'SCRIPT_NAME'} . $tmp2 . $tmp3 . ">" . $tmp4 . "</form>";

}

sub _form_input {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	$tmp1 = "<input $1name=$2$3$2$4>";
	$tmp2 = $1;
	$tmp3 = $2;
	$tmp4 = $3;
	$tmp5 = $4;

	if (($tmp2 =~ /type=(["']?)text/o || $tmp5 =~ /type=(["']?)text/o) || ($tmp2 !~ /type/o && $tmp5 !~ /type/o)) {
		return &_form_text($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} elsif ($tmp2 =~ /type=(["']?)submit/o || $tmp5 =~ /type=(["']?)submit/o) {
		return $tmp1;
	} elsif ($tmp2 =~ /type=(["']?)hidden/o || $tmp5 =~ /type=(["']?)hidden/o) {
		return &_form_hidden($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} elsif ($tmp2 =~ /type=(["']?)checkbox/o || $tmp5 =~ /type=(["']?)checkbox/o) {
		return &_form_checkbox($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} elsif ($tmp2 =~ /type=(["']?)radio/o || $tmp5 =~ /type=(["']?)radio/o) {
		return &_form_radio($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);
	} else {
		return $tmp1;
	}

}

sub _form_hidden {

	my($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//goi;
		$tmp1 =~ s/(\/)?>/ value="$in{$tmp4}" \/>/io;
	}

	return $tmp1;

}

sub _form_checkbox {

	my($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) { $tmp1 =~ s/ checked(=(["']?)checked\2)?//gio; }
	if (ref $in{$tmp4}) {
		foreach (@{$in{$tmp4}}) {
			if ($tmp1 =~ / value=(["']?)$_\1/gio || $tmp1 !~ / value=(["']?).*\1/gio) {
				$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
				last;
			}
		}
	} else {
		if ($tmp1 =~ / value=(["']?)$in{$tmp4}\1/gio || $tmp1 !~ / value=(["']?).*\1/gio) {
			$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
		}
	}

	return $tmp1;

}

sub _form_radio {

	my($tmp1,$tmp2,$tmp3,$tmp4,$tmp5);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ checked(=(["']?)checked\2)?//gio;
		if ($tmp1 =~ / value=(["']?)$in{$tmp4}/gio) {
			$tmp1 =~ s/(\/)?>/ checked="checked" \/>/io;
		}
	}


	return $tmp1;

}


sub _form_text {

	my($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6);

	($tmp1,$tmp2,$tmp3,$tmp4,$tmp5) = @_;

	if (defined $in{$tmp4}) {
		$tmp1 =~ s/ value=$tmp3(.*?)$tmp3//gio;
		$tmp1 =~ s/>/ value="$in{$tmp4}">/io;
	}

	return $tmp1;

}

sub _form_textarea {

	my($tmp1,$tmp2,$tmp3);

	$tmp1 = "<textarea $1name=$2$3$2$4>$in{$3}</textarea>";
	$tmp2 = $2;
	$tmp3 = $3;

	return $tmp1;

}

sub _form_select {

	my($tmp1,$tmp2);

	$tmp1 = "<select $1name=$2$3$2$4>$5</select>";
	$tmp2 = $3;

	if ($in{$tmp2}) {
		$tmp1 =~ s/ selected(=(["']?)selected\2)?//gio;
		$tmp1 =~ s/<(option (.*?)value=(["']?)$in{$tmp2}\3(.*?))>/<$1 selected="selected">/gio;
	}

	return $tmp1;

}

sub open {

	my($return);

	open(FILE,"$_[0].$LANGUAGE") || open(FILE,$_[0]);
	binmode(FILE);
	while (<FILE>) {
		$return .= $_;
	}
	close(FILE);

	return $return;

}

sub write {

	open(FILE,">$_[0]");
	binmode(FILE);
	print FILE $_[1];
	close(FILE);

}

sub language {

	my (%tmp1);

	foreach (split(/,\s*?/,lc($ENV{'HTTP_ACCEPT_LANGUAGE'}))) {
		if ($_ =~ /^(\w+).*;q=(.*)$/) {
			$tmp1{$1} = $2;
		} elsif ($_ =~ /^(\w+?)$/) {
			$tmp1{$1} ||= 1;
		}
	}

	foreach (sort { $tmp1{$b} <=> $tmp1{$a} } keys %tmp1) {
		if (-f "$INSTALLDIR/.language/$_") {
			$LANGUAGE = $_;
			last;
		}
	}

}

sub decode {

	my ($tmp1,$tmp2,$tmp3,$tmp4,$tmp5,$tmp6,$tmp7,$tmp8,$tmp9,$tmp10);
	$tmp1 = $ENV{'REQUEST_METHOD'};
	$tmp2 = $ENV{'QUERY_STRING'};
	$tmp3 = $ENV{'CONTENT_LENGTH'};

	if ($tmp1 eq "POST") {
		binmode(STDIN);
		read(STDIN, $tmp4, $tmp3);
	} else {
		$tmp4 = $tmp2;
	}

	$tmp4 ||= $ARGV[0];

	$tmp4 =~ tr/+/ /;
	@QUERY = split('&', $tmp4);

#	push (@QUERY,@ARGV);

	foreach (@QUERY) {

		if (index($_,"=") < 0) { next; }

		($tmp5,$tmp6) = split(/=/, $_, 2);
		$tmp5 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;
		$tmp6 =~ s/%([a-fA-F0-9]{2})/pack("C", hex($1))/ego;

		$tmp6 =~ s/&/&amp;/go;
		$tmp6 =~ s/</&lt;/go;
		$tmp6 =~ s/>/&gt;/go;
		$tmp6 =~ s/"/&quot;/go;
		$tmp6 =~ s/\r\n?/\n/go;
		$tmp6 =~ s/\\/\\\\/go;

		if ($in{$tmp5}) {
			$tmp7 = $in{$tmp5};
			undef $in{$tmp5};
			push(@{$in{$tmp5}},$tmp7,$tmp6);
		} else {
			$in{$tmp5} = $tmp6;
		}

	}

}

sub print {

	my($print);

	$print = $_[0];

	&form($print);

	$print =~ s/{(.*?)}/$TEXT{$1}/g;

	print $print;

}




